/*Includes ----------------------------------------------*/
#include "tool.h"
#include "nrf_delay.h"
#include "system.h"
#include "ble_comm.h"
#include "bsp_time.h"
#include "hal_led.h"
#include "app_flash.h"
#include "app_wireless_pair.h"

/*Private macro ------------------------------------------------------------------------------------------------------------------------------------*/
#define				APP_WIRELESS_PAIR_FSMTABLE_LEN															8																			//״̬													
#define				APP_WIRELESS_PAIR_RSSI_THRESHOLD														-18																		//rssiֵ

/*Struction ------------------------------------------------------------------------------------------------------------------------------------*/
//״̬ݵö
typedef enum _app_wireless_pair_state
{
	APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY,																																			//Դ״̬
	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION,																																	//׼״̬
	APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS,																																	//Խ״̬
	APP_WIRELESS_PAIR_STATE_END_OF_PAIRING,																																				//Խ״̬
}App_Wireless_Pair_State_e;
//״̬
typedef struct _app_wireless_pair_fsmtable_s
{
	App_Wireless_Pair_Event_e												event;																												//¼
	App_Wireless_Pair_State_e												CurState;																											//ǰ״̬
	int																							(*eventActFun)();																							//ָ
	App_Wireless_Pair_State_e												NextState;																										//һ״̬
}App_Wireless_Pair_fsmtable_s;
//״̬
typedef struct _app_wireless_pair_fsm_s
{
	App_Wireless_Pair_State_e												curState;																											//ǰ״̬
	App_Wireless_Pair_fsmtable_s										FsmTable[APP_WIRELESS_PAIR_FSMTABLE_LEN];											//״̬
	App_Wireless_Pair_Set_Scan_Cb										set_scan_cb;																									//ɨص
	App_Wireless_Pair_Set_Adv_Cb										set_adv_cb;																										//ù㲥ص
	uint8_t																					peer_addr[6];																									//ԶMACַ
	bool																						is_busy;																											//Ƿæµ
	uint8_t																					led_display_count;																						//ƴ
	uint8_t																					led_switch;																										//ƵĿ
	char 																						already_scan_or_adv_mac_buf[16];															//Ѿɨ㲥macַ
}App_Wireless_Pair_Fsm_s;
/*Local Variable ------------------------------------------------------------------------------------------------------------------------------------*/
static App_Wireless_Pair_Fsm_s ob_app_wireless_pair_fsm;

/*Local Functions ------------------------------------------------------------------------------------------------------------------------------------*/
static int app_wireless_pair_set_scan_adv_on(void)
{
	int ret = 0;
	
	//Ьɨ״̬
	//ЬɨӦΪMACַ״̬
	if(mFlash.isHost)
	{
		advertising_stop();
		nrf_ble_scan_stop();
		host_disconnect();
		if(host_isconnect() == 0)
		{
			if(ob_app_wireless_pair_fsm.set_adv_cb != NULL)ret = ob_app_wireless_pair_fsm.set_adv_cb(0x01);
			else ret = -1;
			if(ob_app_wireless_pair_fsm.set_scan_cb != NULL)ret = ob_app_wireless_pair_fsm.set_scan_cb(0x00);
			else ret = -1;
		}
		else
		{
			ret = -1;
		}
	}
	else
	{
		advertising_stop();
		nrf_ble_scan_stop();
		slave_disconnect();
		if(slave_isconnect() == 0)
		{
			if(ob_app_wireless_pair_fsm.set_adv_cb != NULL)ret = ob_app_wireless_pair_fsm.set_adv_cb(0x00);
			else ret = -1;
			if(ob_app_wireless_pair_fsm.set_scan_cb != NULL)ret = ob_app_wireless_pair_fsm.set_scan_cb(0x01);
			else ret = -1;
		}
		else
		{
			ret = -1;
		}
	}
	
	return ret;
}
static int app_wireless_pair_set_scan_adv_off(void)
{
	int 			ret = 0;
	char 			buf[16];
	
	//Ь뱻ɨ״̬
	//ЬɨӦΪ״̬
	if(mFlash.isHost)
	{
		advertising_stop();
		nrf_ble_scan_stop();
		host_disconnect();
		if(host_isconnect() == 0)
		{
			if(ob_app_wireless_pair_fsm.set_adv_cb != NULL)ret = ob_app_wireless_pair_fsm.set_adv_cb(0x00);
			else ret = -1;
			if(ob_app_wireless_pair_fsm.set_scan_cb != NULL)
			{
				sprintf(buf,"%02X%02X%02X%02X%02X%02X",mFlash.macHost[0],mFlash.macHost[1],mFlash.macHost[2],mFlash.mClient.macAddr[3],mFlash.mClient.macAddr[4],mFlash.mClient.macAddr[5]);
				host_set_scan_name(buf,strlen(buf));
				ret = ob_app_wireless_pair_fsm.set_scan_cb(0x00);
			}
			else ret = -1;
		}
		else
		{
			ret = -1;
		}
	}
	else
	{
		advertising_stop();
		nrf_ble_scan_stop();
		slave_disconnect();
		if(slave_isconnect() == 0)
		{
			if(ob_app_wireless_pair_fsm.set_adv_cb != NULL)
			{
				sprintf(buf,"%02X%02X%02X%02X%02X%02X",mFlash.mClient.macAddr[0],mFlash.mClient.macAddr[1],mFlash.mClient.macAddr[2],mFlash.macHost[3],mFlash.macHost[4],mFlash.macHost[5]);
				slave_set_adv_name(buf,strlen(buf));
				slave_adv_init();
				ret = ob_app_wireless_pair_fsm.set_adv_cb(0x00);
			}
			else ret = -1;
		}
		else
		{
			ret = -1;
		}
	}
	
	return ret;
}
static int app_wireless_pair_unconditional_entry(void)
{
	return 0;	//κβֱӽһ״̬
}

static void Bubble_sort(int arr[], int size)
{
	int j,i,tem;
	for (i = 0; i < size-1;i ++)//size-1ΪԼȽϣԱȵһ
	{
		int count = 0;
		for (j = 0; j < size-1 - i; j++)	//size-1-iΪÿһ˾ͻһȽ
		{
			if (arr[j] > arr[j+1])//ŷǰһͺһȽϣǰһλ
			{
				tem = arr[j];
				arr[j] = arr[j+1];
				arr[j+1] = tem;
				count = 1;
				
			}
		}
		if (count == 0)			//ĳһûнλã˵Ѿźֱ˳ѭ
				break;	
		
		//ֵעǺеĶcountΪ˼ǷԪصĽǶԴһŻ
	}
}

static int app_wireless_pair_enter_in_process(int rssi, uint8_t *addr)
{
	#define	N	15
	
	static int 			rssi_buf[N], rssi_filter_buf[N];
	static uint8_t	index = 0;
	int 						ret = 0;
	uint8_t 				null_addr[6] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};

	if(ob_app_wireless_pair_fsm.is_busy == false)
	{
		rssi_buf[index++] = rssi;
		if(index == N)index = 0;
		memcpy(rssi_filter_buf,rssi_buf,sizeof(rssi_buf));
		Bubble_sort(rssi_filter_buf, N);
		
//		SEGGER_RTT_printf(0,"rssi:%d,st:%d,curState:%d,active:%d\r\n",rssi_filter_buf[N-1],NRF_RTC0->COUNTER, \
//																																										 ob_app_wireless_pair_fsm.curState,wireless_pair_scan_get_active());
		
		if(rssi_filter_buf[N-1] >= APP_WIRELESS_PAIR_RSSI_THRESHOLD)
		{
			if(memcmp(addr,null_addr,6) != 0)
			{
				ret = app_wireless_pair_EventHandle(APP_WIRELESS_PAIR_EVENT_RSSI_MEETS_REQUIREMENTS);
				
				for(int i=0; i<6; i++)ob_app_wireless_pair_fsm.peer_addr[i] = addr[5-i];
			}
			else
			{
				ret = app_wireless_pair_EventHandle(APP_WIRELESS_PAIR_EVENT_RSSI_DOES_NOT_MEETS_REQUIREMENTS);
			}
		}
		else
		{
			ret = app_wireless_pair_EventHandle(APP_WIRELESS_PAIR_EVENT_RSSI_DOES_NOT_MEETS_REQUIREMENTS);
		}
	}
	
	return ret;
}

static void display_led_process(void)
{
	ob_app_wireless_pair_fsm.led_display_count++;
	if (ob_app_wireless_pair_fsm.led_display_count % 2 == 0)
	{
			LED_Start(LED_PAIR, COLOR_BLACK);
	}
	else
	{
			LED_Start(LED_PAIR, COLOR_BLUE);
	}
	if (ob_app_wireless_pair_fsm.led_display_count > 20)
	{
			ob_app_wireless_pair_fsm.led_display_count = 0;
			LED_Stop(LED_PAIR);
			Process_SetHoldOn(display_led_process, 0);
			Process_Stop(display_led_process);
	}
}

static void app_wireless_pair_start_display_led(void)
{
	ob_app_wireless_pair_fsm.led_display_count = 0;
  Process_Start(500, "display_led_process", display_led_process);
  Process_SetHoldOn(display_led_process, 1);
}

static void app_wireless_pair_stop_display_led(void)
{
	ob_app_wireless_pair_fsm.led_display_count = 0;
	LED_Stop(LED_PAIR);
	Process_SetHoldOn(display_led_process, 0);
	Process_Stop(display_led_process);
}

static void app_wireless_pair_in_process(void)
{
	int	ret = 0;
	uint8_t *connect_addr;
	uint8_t peer_addr[6];																																				//Զmacַ
	ble_gap_addr_t m_addr;																																			//macַ
	char buf[16];
	uint32_t err_code;

	if(ob_app_wireless_pair_fsm.curState == APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS)
	{
		ob_app_wireless_pair_fsm.is_busy = true;
		
		//ȡӵĶԶmacַ
		connect_addr = wireless_pair_get_connect_macaddr();
		//ȡmacַ
		err_code = sd_ble_gap_addr_get(&m_addr);
		APP_ERROR_CHECK(err_code);
		//ȡԶ˵macַ
		for(int i=0;i<6;i++)peer_addr[i]=ob_app_wireless_pair_fsm.peer_addr[i];
		
		
		if(mFlash.isHost)																			//Ь߼
		{
			//жǷӵmacַΪԵַ
			if(host_isconnect() == 1 && memcmp(peer_addr,connect_addr,6) == 0)
			{
				//жǷԹԹֱӽԽ׶ΡԹ¼MACַԽ
				if(memcmp(peer_addr,mFlash.mClient.macAddr,6) != 0)
				{
					for(int i = 0; i < 6; i++)
					{
						mFlash.mClient.macAddr[i] = peer_addr[i];
						mFlash.macHost[i] 				= m_addr.addr[5-i];
						mBackup.macAddr_L[i] 			= mFlash.macHost[i];         //ַ
						mBackup.macAddr_R[i] 			= mFlash.mClient.macAddr[i]; //ӻַ
					}
					mFlash.mClient.isConfig 		='C';
					mBackup.hardVersion 				= mFlash.mClient.hardVersion;
					mBackup.sotfVersion 				= mFlash.mClient.sotfVersion;
					mBackup.isConfig 						= mFlash.mClient.isConfig;
					if(Flash_SaveBackup() != ZONE_OP_SUCCESS){Except_TxError(EXCEPT_Pair, "pair save backup fail");}
					if(Flash_DeleteAllStep() != ZONE_OP_SUCCESS){Except_TxError(EXCEPT_Pair, "pair clear step fail");}
					memset(&mFlash.mStep, 0, sizeof(FlashStep_t));
					if(Flash_SaveInfomation() != ZONE_OP_SUCCESS){Except_TxError(EXCEPT_Pair, "Flash_SaveInfomation fail");}
				}
				app_wireless_pair_start_led();
				app_wireless_pair_EventHandle(APP_WIRELESS_PAIR_EVENT_PAIR_DONE);
			}
			else
			{
				//ǣϿӣɨΪµԵַ
				sprintf(buf,"%02X%02X%02X%02X%02X%02X",m_addr.addr[5],m_addr.addr[4],m_addr.addr[3],peer_addr[3],peer_addr[4],peer_addr[5]);
				if(memcmp(ob_app_wireless_pair_fsm.already_scan_or_adv_mac_buf,buf,strlen(buf)) != 0)
				{
					advertising_stop();
					nrf_ble_scan_stop();
					host_disconnect();
					if(host_isconnect() == 0)
					{
						ret += ob_app_wireless_pair_fsm.set_adv_cb(0x01);
						host_set_scan_name(buf,strlen(buf));
						ret += ob_app_wireless_pair_fsm.set_scan_cb(0x02);
						if(ret == 0)memcpy(ob_app_wireless_pair_fsm.already_scan_or_adv_mac_buf,buf,strlen(buf));
					}
				}
			}
		}
		else																									//Ь߼
		{
			//жǷӵmacַΪԵַ
			if(slave_isconnect() == 1 && memcmp(peer_addr,connect_addr,6) == 0)
			{
				//жǷԹԹֱӽԽ׶ΡԹ¼MACַԽ
				if(memcmp(peer_addr,mFlash.mClient.macAddr,6) != 0)
				{
					for(int i = 0; i < 6; i++)
					{
						mFlash.mClient.macAddr[i]	=	peer_addr[i];
						mFlash.macHost[i]					=	m_addr.addr[5-i];
						mBackup.macAddr_L[i] 			= mFlash.macHost[i];         //ַ
						mBackup.macAddr_R[i] 			= mFlash.mClient.macAddr[i]; //ӻַ
					}
					mFlash.mClient.isConfig 		='C';
					mBackup.hardVersion 				= mFlash.mClient.hardVersion;
					mBackup.sotfVersion 				= mFlash.mClient.sotfVersion;
					mBackup.isConfig 						= mFlash.mClient.isConfig;
					if(Flash_SaveBackup() != ZONE_OP_SUCCESS){Except_TxError(EXCEPT_Pair, "pair save backup fail");}
					if(Flash_DeleteAllStep() != ZONE_OP_SUCCESS){Except_TxError(EXCEPT_Pair, "pair clear step fail");}
					memset(&mFlash.mStep, 0, sizeof(FlashStep_t));
					if(Flash_SaveInfomation() != ZONE_OP_SUCCESS){Except_TxError(EXCEPT_Pair, "Flash_SaveInfomation fail");}
				}
				app_wireless_pair_start_led();
				app_wireless_pair_EventHandle(APP_WIRELESS_PAIR_EVENT_PAIR_DONE);
			}
			else
			{
				//ǣϿӣù㲥ΪµԵַ
				sprintf(buf,"%02X%02X%02X%02X%02X%02X",peer_addr[0],peer_addr[1],peer_addr[2],m_addr.addr[2],m_addr.addr[1],m_addr.addr[0]);
				if(memcmp(ob_app_wireless_pair_fsm.already_scan_or_adv_mac_buf,buf,strlen(buf)) != 0)
				{
					advertising_stop();
					nrf_ble_scan_stop();
					slave_disconnect();
					if(slave_isconnect() == 0)
					{
						ret += ob_app_wireless_pair_fsm.set_scan_cb(0x01);
						slave_set_adv_name(buf,strlen(buf));
						slave_adv_init();
						ret += ob_app_wireless_pair_fsm.set_adv_cb(0x02);
						if(ret == 0)memcpy(ob_app_wireless_pair_fsm.already_scan_or_adv_mac_buf,buf,strlen(buf));
					}
				}
			}
		}
		ob_app_wireless_pair_fsm.is_busy = false;
	}
}

/*API ------------------------------------------------------------------------------------------------------------------------------------*/
/**
	@brief 		ʼӦ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Init(void)
{
	//ʼṹ
//	memset(&ob_app_wireless_pair_fsm,0,sizeof(App_Wireless_Pair_Fsm_s));																													//mesetʼΪصᱻ
	
	ob_app_wireless_pair_fsm.curState 								= APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY;
	
	ob_app_wireless_pair_fsm.is_busy 									= false;
	
	ob_app_wireless_pair_fsm.led_switch								= 0x01;
	
	//{¼ǰ״̬ҪҪִеĺһ״̬}
	ob_app_wireless_pair_fsm.FsmTable[0].event				=	APP_WIRELESS_PAIR_EVENT_CHARGING_INSERTING;																	//
	ob_app_wireless_pair_fsm.FsmTable[0].CurState			=	APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY;																		//Դ״̬
	ob_app_wireless_pair_fsm.FsmTable[0].eventActFun	=	app_wireless_pair_set_scan_adv_on;																					//ɨ͹㲥
	ob_app_wireless_pair_fsm.FsmTable[0].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION;																//׼״̬
	
	ob_app_wireless_pair_fsm.FsmTable[1].event				=	APP_WIRELESS_PAIR_EVENT_CHARGING_UNPLUG;																		//γ
	ob_app_wireless_pair_fsm.FsmTable[1].CurState			=	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION;																//׼״̬
	ob_app_wireless_pair_fsm.FsmTable[1].eventActFun	=	app_wireless_pair_set_scan_adv_off;																					//ɨ͹㲥
	ob_app_wireless_pair_fsm.FsmTable[1].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY;																		//Դ״̬
	
	ob_app_wireless_pair_fsm.FsmTable[2].event				=	APP_WIRELESS_PAIR_EVENT_RSSI_MEETS_REQUIREMENTS;														//rssiҪ
	ob_app_wireless_pair_fsm.FsmTable[2].CurState			=	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION;																//׼״̬
	ob_app_wireless_pair_fsm.FsmTable[2].eventActFun	=	app_wireless_pair_unconditional_entry;																			//ֱӽһ״̬
	ob_app_wireless_pair_fsm.FsmTable[2].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS;																//Խ״̬
	
	ob_app_wireless_pair_fsm.FsmTable[3].event				=	APP_WIRELESS_PAIR_EVENT_CHARGING_UNPLUG;																		//γ
	ob_app_wireless_pair_fsm.FsmTable[3].CurState			=	APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS;																//Խ״̬
	ob_app_wireless_pair_fsm.FsmTable[3].eventActFun	=	app_wireless_pair_set_scan_adv_off;																					//ɨ͹㲥
	ob_app_wireless_pair_fsm.FsmTable[3].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY;																		//Դ״̬
	
	ob_app_wireless_pair_fsm.FsmTable[4].event				=	APP_WIRELESS_PAIR_EVENT_RSSI_DOES_NOT_MEETS_REQUIREMENTS;										//rssiҪ
	ob_app_wireless_pair_fsm.FsmTable[4].CurState			=	APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS;																//Խ״̬
	ob_app_wireless_pair_fsm.FsmTable[4].eventActFun	=	app_wireless_pair_unconditional_entry;																			//ֱӽһ״̬
	ob_app_wireless_pair_fsm.FsmTable[4].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION;																//׼״̬
	
	ob_app_wireless_pair_fsm.FsmTable[5].event				=	APP_WIRELESS_PAIR_EVENT_PAIR_DONE;																					//					
	ob_app_wireless_pair_fsm.FsmTable[5].CurState			=	APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS;																//Խ״̬
	ob_app_wireless_pair_fsm.FsmTable[5].eventActFun	=	app_wireless_pair_unconditional_entry;																			//ֱӽһ״̬
	ob_app_wireless_pair_fsm.FsmTable[5].NextState		=	APP_WIRELESS_PAIR_STATE_END_OF_PAIRING;																			//Խ״̬
	
	ob_app_wireless_pair_fsm.FsmTable[6].event				=	APP_WIRELESS_PAIR_EVENT_CHARGING_UNPLUG;																		//γ	
	ob_app_wireless_pair_fsm.FsmTable[6].CurState			=	APP_WIRELESS_PAIR_STATE_END_OF_PAIRING;																			//Խ״̬
	ob_app_wireless_pair_fsm.FsmTable[6].eventActFun	=	app_wireless_pair_set_scan_adv_off;																					//ɨ͹㲥
	ob_app_wireless_pair_fsm.FsmTable[6].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_STANDBY;																		//Դ״̬
	
	ob_app_wireless_pair_fsm.FsmTable[7].event				=	APP_WIRELESS_PAIR_EVENT_RSSI_DOES_NOT_MEETS_REQUIREMENTS;										//rssiҪ
	ob_app_wireless_pair_fsm.FsmTable[7].CurState			=	APP_WIRELESS_PAIR_STATE_END_OF_PAIRING;																			//Խ״̬
	ob_app_wireless_pair_fsm.FsmTable[7].eventActFun	=	app_wireless_pair_unconditional_entry;																			//ֱӽһ״̬
	ob_app_wireless_pair_fsm.FsmTable[7].NextState		=	APP_WIRELESS_PAIR_STATE_PAIRING_PREPARATION;																//׼״̬
	
	Process_Start(0,"app_wireless_pair_in_process",app_wireless_pair_in_process);
	
	return 0;
}

/**
	@brief 		עɨ
	@param 		cb								-	[in]	עĻص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Regist_SetScan(App_Wireless_Pair_Set_Scan_Cb cb)
{
	if(cb != NULL)
	{
		ob_app_wireless_pair_fsm.set_scan_cb = cb;
		return 0;
	}
	return -1;
}

/**
	@brief 		ע㲥
	@param 		cb								-	[in]	עĻص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Regist_SetAdv(App_Wireless_Pair_Set_Adv_Cb cb)
{
	if(cb != NULL)
	{
		ob_app_wireless_pair_fsm.set_adv_cb = cb;
		return 0;
	}
	return -1;
}

/**
	@brief 		ɨ
	@param 		rssi							-	[in]	źǿ
	@param 		addr							-	[in]	MACַָ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Scan_Req(int rssi, uint8_t *addr)
{
	int ret = 0;
	
	if(mFlash.isHost)
	{
		app_wireless_pair_enter_in_process(rssi,addr);
	}
	else
	{
		ret = -1;					//ֻЬյЬɨŶ
	}
	
	return ret;
}

/**
	@brief 		ɨظ
	@param 		rssi							-	[in]	źǿ
	@param 		addr							-	[in]	MACַָ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_Scan_Rsp(int rssi, uint8_t *addr)
{
	int ret = 0;
	
	if(!mFlash.isHost)
	{
		app_wireless_pair_enter_in_process(rssi,addr);
	}
	else
	{
		ret = -1;					//ֻЬյЬɨӦŶ
	}
	
	return ret;
}

/**
	@brief 		
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_start_led(void)
{
//	SEGGER_RTT_printf(0,"start: curState:%d\r\n",ob_app_wireless_pair_fsm.curState);
	if(ob_app_wireless_pair_fsm.led_switch != 0 && (ob_app_wireless_pair_fsm.curState == APP_WIRELESS_PAIR_STATE_PAIRING_IN_PROGRESS))
	{
		ob_app_wireless_pair_fsm.led_switch--;
		app_wireless_pair_start_display_led();
//		SEGGER_RTT_printf(0,"app_wireless_pair_start_display_led\r\n");
	}
	return 0;
}

/**
	@brief 		
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_stop_led(void)
{
//	SEGGER_RTT_printf(0,"stop: curState:%d\r\n",ob_app_wireless_pair_fsm.curState);
	app_wireless_pair_stop_display_led();
	ob_app_wireless_pair_fsm.led_switch = 1;
	app_wireless_pair_EventHandle(APP_WIRELESS_PAIR_EVENT_RSSI_DOES_NOT_MEETS_REQUIREMENTS);
//	SEGGER_RTT_printf(0,"app_wireless_pair_stop_display_led\r\n");
	return 0;
}

/**
	@brief 		¼
	@param 		event							-	[in]	¼
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	app_wireless_pair_EventHandle(App_Wireless_Pair_Event_e  event)
{
	int (*eventActFun)() = NULL;  	//ָʼΪ
	App_Wireless_Pair_State_e NextState;
	int flag = 0; 									//ʶǷ
	int i;
	int ret = 0;
	
	
	/*ȡǰ*/
	for (i = 0; i<APP_WIRELESS_PAIR_FSMTABLE_LEN; i++)
	{
			//ҽǰ״ָ̬¼Ҳִ
			if (event == ob_app_wireless_pair_fsm.FsmTable[i].event && ob_app_wireless_pair_fsm.curState == ob_app_wireless_pair_fsm.FsmTable[i].CurState)
			{
					flag = 1;
					eventActFun = ob_app_wireless_pair_fsm.FsmTable[i].eventActFun;
					NextState = ob_app_wireless_pair_fsm.FsmTable[i].NextState;
					break;
			}
	}
	
	if (flag) //
	{
		/*ִ*/
		if(eventActFun)
		{
			ret = eventActFun();
		}

		//תһ״̬
		if(ret == 0)
		{
			ob_app_wireless_pair_fsm.curState = NextState;
		}
	}
	else
	{
		//there is no match
		ret = -1;
	}
	
	return ret;
}

















